/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.blocks.wood;

import java.util.EnumMap;

import net.minecraft.block.BlockTrapDoor;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.init.Blocks;

import net.dries007.tfc.objects.Wood;
import net.dries007.tfc.util.OreDictionaryHelper;

public class BlockTrapDoorWoodTFC extends BlockTrapDoor
{
    private static final EnumMap<Wood, BlockTrapDoorWoodTFC> MAP = new EnumMap<>(Wood.class);

    public static BlockTrapDoorWoodTFC get(Wood wood)
    {
        return MAP.get(wood);
    }

    public final Wood wood;

    public BlockTrapDoorWoodTFC(Wood wood)
    {
        super(Material.field_151575_d);
        this.wood = wood;
        if (MAP.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
        func_149711_c(0.5F);
        func_149672_a(SoundType.field_185848_a);
        OreDictionaryHelper.register(this, "wood", "trapdoor");
        Blocks.field_150480_ab.func_180686_a(this, 5, 20);
    }
}
