/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic.chunkdata;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.util.math.BlockPos;

import net.dries007.tfc.objects.Ore;
import net.dries007.tfc.util.OreSpawnData;

public class ChunkDataOreSpawned
{
    public final Ore ore;
    public final OreSpawnData.SpawnSize size;
    public final Ore.Grade grade;
    public final BlockPos pos;
    public final int count;

    public ChunkDataOreSpawned(Ore ore, OreSpawnData.SpawnSize size, Ore.Grade grade, BlockPos pos, int count)
    {
        this.ore = ore;
        this.size = size;
        this.grade = grade;
        this.pos = pos;
        this.count = count;
    }

    public ChunkDataOreSpawned(NBTTagCompound tag)
    {
        ore = Ore.valueOf(tag.func_74779_i("ore").toUpperCase());
        grade = Ore.Grade.valueOf(tag.func_74779_i("grade").toUpperCase());
        size = OreSpawnData.SpawnSize.valueOf(tag.func_74779_i("size").toUpperCase());
        pos = NBTUtil.func_186861_c(tag.func_74775_l("pos"));
        count = tag.func_74762_e("count");
    }

    public NBTTagCompound serialize()
    {
        NBTTagCompound root = new NBTTagCompound();
        root.func_74778_a("ore", ore.name());
        root.func_74778_a("grade", grade.name());
        root.func_74778_a("size", size.name());
        root.func_74782_a("pos", NBTUtil.func_186859_a(pos));
        root.func_74768_a("count", count);
        return root;
    }

    @Override
    public String toString()
    {
        return "OreSpawned{" +
                "ore=" + ore +
                ", grade=" + grade +
                ", pos=" + pos +
                ", count=" + count +
                '}';
    }
}
